import java.util.HashSet;
import java.util.Set;

import algorithms.TestClass;
import chromosome.Ant;
import chromosome.Data;

/**
 * Receives three arguments: path to file with data, number of ants used and number of iterations.
 * @author ivan
 *
 */
public class TSPSolver {


	private static int numOfCandidates;
	private static int antNumber;
	private static int maxIter;

	public static void main(String[] args) {
		if (args.length != 3) {
			System.err.println("Wrong number of parameters. Please repeat your request.");
			return;
		}

		Data data = new Data(args[0]);
		data.parse();
		

		try {
			antNumber = Integer.parseInt(args[1]);
			maxIter = Integer.parseInt(args[2]);
		} catch (NumberFormatException e) {
			System.err.println("One or more parameters are wrong.");
			return;
		}

		TestClass antSystem = new TestClass(data.getDistances(), maxIter, antNumber);
		Ant solution = antSystem.runAlgorithm();
		System.out.println("Rezultat: " + solution.getTourLength());
		System.out.println("Put: " + solution.getTour().toString());


	}
}