package chromosome;

import java.util.ArrayList;
import java.util.List;
/**
 * Class representing ant used as chromosome for ant system algorithms.
 * 
 * @author Ivan Vlašić
 *
 */

public class Ant implements Comparable<Ant> {
	private List<Integer> tour;
	private double tourLength;

	public Ant() {
		this.tour = new ArrayList<>();
		this.tourLength = 0;
	}
	
	public Ant(Ant ant) {
		this.tour = new ArrayList<>(ant.tour);
		this.tourLength = ant.tourLength;
	}

	public void addInTour(Integer city) {
		this.tour.add(city);
	}
	
	public List<Integer> getTour() {
		return this.tour;
	}
	
	public double getTourLength() {
		return tourLength;
	}
	
	
	public void setTourLength(double tourLength) {
		this.tourLength = tourLength;
	}

	@Override
	public int compareTo(Ant o) {
		if (this.tourLength < o.tourLength) {
			return -1;
		}

		if (this.tourLength > o.tourLength) {
			return 1;
		}

		return 0;
	}

}
