package selection;

import java.util.List;
import java.util.NoSuchElementException;
import java.util.Random;




public class RouletteWheelSelection implements ISelection {

	private Random rand;
	private double[] probabilities;

	public RouletteWheelSelection(double[] probabilities) {
		this.rand = new Random();
		this.probabilities = probabilities;
	}

	@Override
	public Integer selection(List<Integer> forSelection) {
		double chance = rand.nextDouble();
		double total = 0.0;
		double currSum = 0.0;
		int size = forSelection.size();

		for (int i = 0; i < size; i++) {
			total += probabilities[i];
		}
		for (int i = 0; i < size; i++) {
			currSum += probabilities[i];
			if ((currSum / total) >= chance) {
				return forSelection.get(i);
			}
		}

		throw new NoSuchElementException("Something is wrong with roulette wheel selection.");

	}

}
