package selection;

import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;



public class TournamentSelection implements ISelection {
	
	private int tournamentSize;
	private Random rand;
	
	public TournamentSelection(int tournamentSize) {
		this.tournamentSize = tournamentSize;
		this.rand = new Random();
	}

	@Override
	public Integer selection(List<Integer> forSelect) {
		Set<Integer> selection = new HashSet<>();
		
		while (selection.size() < tournamentSize) {
			selection.add(forSelect.get(rand.nextInt(forSelect.size())));
		}
		
		return Collections.min(selection);
	}

}
